def sw(Cluster_Data, count_size_filter, total_output, snp_output, gene_exp_output):
    gene_exp = {}
    f_snp = open(snp_output, 'w')
    f_geneexp = open(gene_exp_output, 'w')
    f_output = open(total_output,'w')
    ribokeys = [['+RIBO12S'],['+RIBO16S'],['+RIBO18S'],['+RIBO28S'],['+RIBO5.8S'],['+TRNA'],['-RIBO12S'],['-RIBO16S'],['-RIBO18S'],['-RIBO28S'],['-TRNA']]
    f_output.write('%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s\n' % 
                ('num_refseq', 'num_gid', 'num_gname', 'num_classes', \
            'string_rna_class', 'string_gene_ids', 'string_gene_names', \
            'strand', 'ref', 'pos', \
            'size', 'num_mism', 'complexity', \
            'centroid_x', 'centroid_y', \
            'a_quality_pbm', 'a_quality_avg_pbm', 'b_quality_pbm', 'b_quality_avg_pbm', \
            'bounding_box', 'pix_x', 'pix_y', 
            'read', 'component', 'intensity'))
    for key in Cluster_Data.keys():
        clust = Cluster_Data[key]
        if clust.best:
            best = clust.best_class
            gene_names = clust.get_gene_names(best)
            gene_ids = clust.get_gene_ids(best)
            rna_class = clust.get_rna_class(best)
            alignment_details = clust.get_alignment_details(best)
            stats = clust.get_stats()
            # Exception for ribosomal RNAs and tRNAs
            if rna_class in ribokeys:
                gene_names = [rna_class[0][1:]]
            # Process alignment details
            refseq = []
            strand = []
            posit = []
            for alignment in alignment_details:
                refseq.append(alignment[0])
                strand.append(alignment[1])
                posit.append(str(alignment[2]))
            # FORMAT
            num_refseq = len(refseq)
            num_gid = len(gene_ids)
            num_gname = len(gene_names)
            num_classes = len(rna_class)
            string_rna_class = ','.join(rna_class)
            string_gene_ids = ','.join(gene_ids)
            string_gene_names = ','.join(gene_names)
            strand = ','.join(strand)
            ref = ','.join(refseq)
            pos = ','.join(posit)
            size = stats[0]
            complexity = stats[1]
            centroid_x = str(stats[2][0])
            centroid_y = str(stats[2][1])
            num_mism = stats[10]
            a_quality_pbm = ','.join([str(x) for x in stats[3]])
            a_quality_avg_pbm = str(stats[4])
            b_quality_pbm = ','.join([str(x) for x in stats[5]])
            b_quality_avg_pbm = str(stats[6])
            bounding_box = ','.join([str(x) for x in stats[7]])
            pix_x = ','.join([str(x) for x in stats[8]])
            pix_y = ','.join([str(x) for x in stats[9]])
            read = ','.join([str(x) for x in stats[11]])
            component = ','.join([str(x) for x in stats[13].max(axis=1)])
            intensity = ','.join([str(x) for x in stats[14][:,0:4].sum(axis=1)])
            string = "%d\t%d\t%d\t%d\t%s\t%s\t%s\t%s\t%s\t%s\t%d\t%d\t%f\t%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s\n" % \
            (num_refseq, num_gid, num_gname, num_classes, \
            string_rna_class, string_gene_ids, string_gene_names, \
            strand, ref, pos, \
            size, num_mism, complexity, \
            centroid_x, centroid_y, \
            a_quality_pbm, a_quality_avg_pbm, b_quality_pbm, b_quality_avg_pbm, \
            bounding_box, pix_x, pix_y, 
            read, component, intensity)
            f_output.write(string)
            if size > count_size_filter and num_gname == 1:
                try:
                    gene_exp[gene_names[0]] += 1
                except KeyError:
                    gene_exp[gene_names[0]] = 1
            if size > count_size_filter and num_mism > 0:
                f_snp.write('%s\n' % (','.join([strand, ref, pos, ','.join(clust.container[best[0]].consensus_mismatches)])))
    f_output.close()
    for key in gene_exp:
        f_geneexp.write('%s,%d\n' % (key, gene_exp[key]))
    f_geneexp.close()
    f_snp.close()
    return gene_exp